import akka.actor.ActorSystem
import akka.stream.Materializer
import akka.stream.scaladsl._
import scala.concurrent.Future
import scala.concurrent.ExecutionContext
import akka.NotUsed
import scala.concurrent.duration._
import akka.stream.OverflowStrategy

given system: ActorSystem = ActorSystem("paint")
given ExecutionContext = system.dispatcher
given Materializer = Materializer(system)

def sum =
  val source1 = Source.tick(1.second,1.second,0)
  val source2 = Source(Stream.iterate(0)(_ + 1))
  val source = source1.zip(source2)
  val sink = Sink.foreach[Any](i => println("step: " + i))
  val sum = source runWith sink
  sum

def error1 =
  val source = Source(0 to 5).map(100 / _)  
  val result = source.runWith(Sink.fold(0)(_ + _))
  result

def error2 =
  val source = Source(0 to 5).map(100 / _).recover {
    case _: ArithmeticException => 0
  }
  val result = source.runWith(Sink.fold(0)(_ + _))
  result